/* This `webattery` is a battery power displaying program.
 * Copyright (C) 2009, 2010 Alagunambi Welkin <alagunambiwelkin@gmail.com>.
 *
 * This file is part of Webattery.
 *
 * Webattery is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Webattery is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Webattery.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <getopt.h>
#include <dirent.h>

#define PRE_FILE_PATH "/proc/acpi/battery/"	// Default Path
#define WEBATTERY "Webattery-1.2"		// Name & Version
#define BC 32					// Border Color
#define MAX_LEN 256				// Max length for array
/* This function finds no. of directories beyond /proc/acpi/battery? */
int find_dirs(void);

/* This function is for displaying the help menu */
void print_usage(FILE * stream, int exit_code);

/* This function is for opening and closing the required battery files in /proc */
int file_work(char *file_path);

/* This function is for extracting the required datas from the opened file */
void string_match(char *match_string, char choice);

/* This function is for finding the total output string length */
int total_str_len(void);

/* This function is for the border which you see in battery */
int border(void);

/* This function is for display the battery power and status in text */
int batt_output(int color_val, int some);

/* This function is for printing the output of battery command according to its power status */
void colour_print(char chuma);

/* This function helps to print a compact view of battery */
void output_type(char type);

/* This function is for printing the vebose details */
int we_verbose(void);

/* This function is for estimating the charging and discharging time */
int batt_time(void);


/**********************************************************************
 Declaring variables for displaying battery information. 
**********************************************************************/

struct batt_verbose
{
  char			we_design_capacity[MAX_LEN];
  char			we_design_voltage[MAX_LEN];
  char			we_serial_number[MAX_LEN];
  char			we_type[MAX_LEN];
  char			we_oem_info[MAX_LEN];
  char			we_battery_type[MAX_LEN];
  char			we_present_voltage[MAX_LEN];
  char			we_charging_state[MAX_LEN];
  char			we_capacity_state[MAX_LEN];
  char			we_battery_technology[MAX_LEN];
  char			we_design_capacity_warning[MAX_LEN];
  char			we_design_capacity_low[MAX_LEN];
  char			we_model_number[MAX_LEN];
  char			we_manufactured_date[MAX_LEN];
  unsigned int		we_present_rate;
  unsigned int		we_remaining_capacity;
  unsigned int		we_last_full_capacity;
}we_batt;

struct batt_unit
{
  char			we_unit_design_capacity[MAX_LEN];
  char			we_unit_last_full_capacity[MAX_LEN];
  char			we_unit_design_voltage[MAX_LEN];
  char			we_unit_design_capacity_warning[MAX_LEN];
  char			we_unit_design_capacity_low[MAX_LEN];
  char			we_unit_present_rate[MAX_LEN];
  char			we_unit_remaining_capacity[MAX_LEN];
  char			we_unit_present_voltage[MAX_LEN];
}we_unit;

char			temp[500];
char			*match = NULL;
char			display_out[MAX_LEN];
char			file1_path[MAX_LEN];
char			file2_path[MAX_LEN];
const char	 	*program_name = NULL;
const char		*dir = NULL;

size_t			file_content;

struct			dirent **dir_list;

signed int		BATT = 0;
unsigned short int	total_string_len = 0;
unsigned short int	i = 0;
